#import "MultiGetterConcatenator.h"
#import <ncurses.h>
	
@implementation MultiGetterConcatenator
	
- (id)initWithSegmentNum: (int)n
{
	[super init];
	segment = 0;
	segmentNum = n;
	return self;
}

- (void)setPath: (NSString *)str
{
	path = [str retain];
}

- (void)increaseSegment
{
	segment++;
}

- (void)decreaseSegment
{
	int i, ret;
	segment--;
	if(segment == 0) {
		[[timer userInfo] printProgress];
		[timer invalidate];
		refresh();
		endwin();
		printf("concatenating file...");
		fflush(stdout);
		char *buffer = (char *)malloc(65536);
		FILE *fpw = fopen([path UTF8String], "wb");
		NSString *filename = [path lastPathComponent];
		NSString *dst = [[path stringByDeletingLastPathComponent] stringByAppendingPathComponent: [NSString stringWithFormat: @"%@_segments",filename]];
		for(i=0;i<segmentNum;i++) {
			FILE *fpr = fopen([[dst stringByAppendingPathComponent: [NSString stringWithFormat: @"%@.%d", filename, i+1]] UTF8String], "rb");
			while(1) {
				ret = fread(buffer, 1, 65536, fpr);
				if(ret > 0) fwrite(buffer, 1, ret, fpw);
				if(ret < 65536) break;
			}
			fclose(fpr);
		}
		fclose(fpw);
		NSFileManager *fm = [NSFileManager defaultManager];
		[fm removeFileAtPath: dst handler: nil];
		printf("finished.\n");
		printf("[%s] saved.\n", [filename cString]);
		exit(0);
	}
}

- (void)addTimer: (NSTimer *)t
{
	timer = t;
}
	
@end