#import <Foundation/Foundation.h>
#import "MultiGetterFilesizeDecider.h"
#import <unistd.h>

int main(int argc, char *argv[])
{
	extern char *optarg ;
	extern int optind;
	int i=0, segment=5;
	BOOL isDir;
	char opt;
	
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSFileManager *fm = [NSFileManager defaultManager];
	NSString *dir = [fm currentDirectoryPath];
	NSString *referer= nil;
	
	while((opt = getopt(argc,argv,"o:r:s:")) != -1) {
		switch(opt) {
		  case 'o' :
			if(optarg) {
				if(*optarg != '/')
					dir = [[dir stringByAppendingPathComponent: [NSString stringWithUTF8String: optarg]] stringByStandardizingPath];
				else
					dir = [[NSString stringWithUTF8String: optarg] stringByStandardizingPath];
			}
			break;
		  case 'r' :
			if(optarg) referer = [NSString stringWithCString: optarg];
			break;
		  case 's' :
			segment = atoi(optarg);
			if(segment < 2) segment = 5;
			break;
		}
		i++;
	}
	
	if(argc <= i+1) {
		printf("multigetter by tmkk\n usage: %s [-o outputDir] [-r referer] [-s segmentNum] <URL>\n",argv[0]);
		return 0;
	}
	
	BOOL ret = [fm fileExistsAtPath:dir isDirectory:&isDir];
	if(!ret || !isDir) dir = [fm currentDirectoryPath];
	
	NSURL *url = [NSURL URLWithString: [NSString stringWithCString: argv[optind]]];
	NSMutableURLRequest *req = [NSMutableURLRequest requestWithURL: url];
	[req setHTTPMethod: @"GET"];
	//[req setValue: @"Keep-Alive" forHTTPHeaderField: @"Connection"];
	//[req setValue: @"timeout=120, max=99" forHTTPHeaderField: @"Keep-Alive"];
	MultiGetterFilesizeDecider *del = [[MultiGetterFilesizeDecider alloc] initWithSegmentNum: segment outputDir: dir];
	if(referer) [del setReferer: referer];
	[[NSURLDownload alloc] initWithRequest: req delegate: del];
	
	[[NSRunLoop currentRunLoop] run];
	
	[pool release];
	return 0;
}